-- Monadic analogue of the following ML ill-typed program:
--
--   let r = new []
--   r := ["1"]
--   List.fold_left (+) 0 !r
--

module M where

import Data.IORef

n :: IO (IORef [a])
n = newIORef []

p :: IO ()
p = n >>= \r -> writeIORef r ["1"]

q :: IO Int
q = n >>= \r -> readIORef r >>= \l -> return (foldl (+) 0 l)

-- The above is well-typed, but not this:
-- pq :: IO Int
-- pq = do
--   r <- newIORef [];
--   writeIORef r ["1"];
--   l <- readIORef r;
--   return (foldl (+) 0 l)
